/***************************************************************************
                          CHAT_Room.cc  -  description
                             -------------------
    begin                : Fri Jun 22 2001
    copyright            : (C) 2001 by Ganda,Gatot
    email                : ganda_kusuma@usa.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "CHAT_Room.hh"
#include "CHAT_User.hh"
#include <stdio.h>

CHAT_Room::CHAT_Room()
{
  int i;
  maxUsersCv = MAX_USER_PER_ROOM;
  for (i=0;i<maxUsersCv;i++)
    usersPtrCv[i] = NULL;
}

CHAT_Room::~CHAT_Room()
{
  int i;
  for (i=0;i<maxUsersCv;i++)
    usersPtrCv[i] = NULL;
}
    
Status
CHAT_Room::Join(CHAT_User * userPtr)
{
  int i;
  for (i = 0;i < maxUsersCv;i++) {
    if (usersPtrCv[i] == NULL) {
      usersPtrCv[i] = userPtr;
      userPtr->SetRoom(this);
	    return (OK);
     }
  }
  return (ERROR);
}
  
Status
CHAT_Room::Leave (CHAT_User *userPtr)
 {
  char string[100];
  int i;
  for (i=0; i< maxUsersCv; i++) {
    if (usersPtrCv[i] == userPtr) {
      usersPtrCv[i] = NULL;//found!
      sprintf(string, "ROOM: User name %s has quit.\n",
              userPtr->userNameCv);
      Broadcast (string);
    return (OK);
    }
  }
  return (ERROR);
}

void
CHAT_Room::Broadcast(char* str)
{
  int i;//,len;

 // len = strlen(str);
//  for (i=0; i<len;i++)
  for (i=0; i<maxUsersCv; i++) {
     if (usersPtrCv[i] != NULL) {
     usersPtrCv[i]->SendMessage(str);
    }
  }
}


void
CHAT_Room::Broadcasts(char* str, int len)
{
  int i;
  char buf[100];
  for (i=0; i<maxUsersCv; i++) {
   if (usersPtrCv[i] != NULL) {
      sprintf(buf, "%s ",str);
      usersPtrCv[i]->SendMessage(buf);
    }
  }
}

void
CHAT_Room::DisconnectAll()  //this methode is intended only for lobby
{
  int i;
  for (i=0;i<MAX_USER;i++){
   if (usersPtrCv[i] != NULL){
      delete usersPtrCv[i];
    }
  }
}
