#include <stdio.h>
#include "CHAT_User.hh"
#include "CHAT_Room.hh"
#include "CHAT_Manager.hh"
#include "CHAT_Login.hh"



CHAT_User::CHAT_User(SOCK_Socket *socketPtr)
{  
   roomPtrCv = NULL; 
   socketPtrCv = socketPtr;
}
       
CHAT_User::~CHAT_User()
{
  if (socketPtrCv != NULL)
  {
    delete socketPtrCv;
  }
}
  
void 
CHAT_User::SetRoom (CHAT_Room *roomPtr)
{
  roomPtrCv = roomPtr;
}

void
CHAT_User::SetManager (CHAT_Manager *managerPtr)
{
  managerPtrCv = managerPtr;
}

void
CHAT_User::SetLogin (CHAT_Login *loginPtr) //relogin
{
  loginPtrCv = loginPtr;
}


void
CHAT_User::Run ()
{
  char str[100];
  char str2[100];
  Boolean q=FALSE;
  CHAT_Room * newRoomPtr ;
  CHAT_User * victim;

  isOkToSendCv = FALSE;
  loginPtrCv->GetUserName(this);
  while (!q) {
    if (GetMessage(str)!=OK){
      printf("CHAT_User: Closing remote connection.\n");
      goto EXIT;
    };
    if (str[0] == '/') {
      switch (str[1]) {

        case '`' :
          victim = loginPtrCv->GetUserPtrByName(&str[3]);
          if (victim!=NULL){
            delete victim;
          }
          break;

        case 'q' :
           q = TRUE;
          break;

        case 'n' :
          if (!(loginPtrCv->IsUserNameIn(&str[3]))) {
            sprintf(str2, "CHAT SERVER: %s is now %s\n",
                    userNameCv ,&str[3]);
            roomPtrCv->Broadcast(str2);
            strcpy (userNameCv,&(str[3]));
          } else {
            SendMessage("That name is already in use\n");
          }
          break;

        case 'c':
          newRoomPtr = NULL;
          if (str[3] != '\0') {
            newRoomPtr = new CHAT_Room;
            if (newRoomPtr != NULL){
              if (!(managerPtrCv->IsRoomIn(&str[3])))
              {
                managerPtrCv->RoomRegister(newRoomPtr);
                strcpy(newRoomPtr->roomNameCv, &str[3]);
                sprintf(str2,"CHAT_USER: room %s is created.\n",&str[3]);
                SendMessage (str2);
              }
            } else {
              SendMessage("CHAT_USER: Cannot create more room.\n");
            }
          } else {
            SendMessage("CHAT_USER: Please use valid room name.\n");
          }
          break;

        case '?':
          DisplayHelp();
          break;

        case 'R':
          managerPtrCv->DisplayAllRoomName(this);
          break;

        case 'U':
          loginPtrCv->DisplayAllUser(this);
          break;

        case 'K':
          break;

        case 'j':
          if (str[3]!= '\0') {
            if (managerPtrCv->IsRoomIn(&str[3])){
              roomPtrCv->Leave(this);
              roomPtrCv=managerPtrCv->GetRoomPtrByName(&str[3]);
              //printf("USER: GetRoomPtrByName %p\n",roomPtrCv);
              sprintf(str2,"%s joined room %s.\n",userNameCv,&str[3]);
              roomPtrCv->Join(this);
              roomPtrCv->Broadcast (str2);
            } else {
            sprintf(str2,"No such room %s.\n",&str[3]);
            SendMessage (str2);
            }
          } else {
            SendMessage("CHAT_USER: Please use valid room name.\n");
          }
          break;

        default:
          roomPtrCv->Broadcast(str);
          break;
        }
    } else {
      sprintf(str2,"%s: %s\n",userNameCv, str);
      roomPtrCv->Broadcast (str2);
    }
  }

EXIT:
  roomPtrCv->Leave(this);
  loginPtrCv->Logout(this);
  delete socketPtrCv;
  return;
}
  
Status
CHAT_User::SendMessage (char *string)
{
  if (isOkToSendCv){
    return (socketPtrCv->PutString (string));
  } else {
    return (OK);
  }
}

Status
CHAT_User::SendMessages (char *string, int len)
{
  return (socketPtrCv->PutStrings ((string), len));
}

Status
CHAT_User::GetMessage (char * str)
{
  Status st;
  int i,len;

  st =  socketPtrCv->GetString(str);
  len = strlen (str);
  // filter out bad characters

  for (i=0;i<len;i++){
    if (str[i] < '\27' ){
      str[i] =' ';
    }
  }
  str[len-2] ='\0';

  return (st);
}

void
CHAT_User::DisplayHelp ()
{
  SendMessage("Instructions:\n");
  SendMessage("+------------+-------------------------+\n");
  SendMessage("|   Syntax   |     Action              |\n");
  SendMessage("+------------+-------------------------+\n");
  SendMessage("| /?         |   Display this help.    |\n");
  SendMessage("| /j [room]  |   Join to a room        |\n");
  SendMessage("| /R         |   Display all room      |\n");
  SendMessage("| /c [room]  |   Create room.          |\n");
  SendMessage("| /q         |   Quit nicely.          |\n");
  SendMessage("| /n [name]  |   Set your nickname.    |\n");
  SendMessage("| /U         |   Display all user name.|\n");
  SendMessage("+------------+-------------------------+\n");
}


void
CHAT_User::StopReceive()
{
  isOkToSendCv=FALSE;
};

void
CHAT_User::StartReceive()
{
  isOkToSendCv=TRUE;
};

