#ifndef __CHAT_USER_HH__
#define __CHAT_USER_HH__

#include "SOCK_Socket.hh"
#include "Global.h"
#include "Thread.hh"

class CHAT_Room;       //prototypes
class CHAT_Manager;
class CHAT_Login;

class CHAT_User : public Thread
{
private:
  SOCK_Socket 	  *socketPtrCv;
//  CHAT_Room       *roomPtrCv;
  CHAT_Manager    *managerPtrCv;
  CHAT_Login      *loginPtrCv;
  Boolean          isOkToSendCv;

  int         		myPid;
  int         		myPPid;

public:
  char userNameCv[20];
  CHAT_Room       *roomPtrCv;
 
  CHAT_User(SOCK_Socket *socketPtr);

  ~CHAT_User();

  void
  Run();

  void
  SetRoom (CHAT_Room *roomPtr);

  void
  SetLogin (CHAT_Login *loginPtr);

  void
  SetName (char *nameBuf);

  void
  StopReceive();

  void
  StartReceive();

  Status
  SendMessage (char *string);

  void
  SetManager (CHAT_Manager *managerPtr);

  Status
  SendMessages (char *string, int len);

  Status
  GetMessage (char *string);

  void
  DisplayHelp ();
};

#endif