#ifndef __SOCK_Socket_hh__
#define __SOCK_Socket_hh__

#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include "Global.h"
    
class SOCK_Socket
{
private:
  struct sockaddr_in sinCv;
  int                sinFdCv;
  Boolean            serverFlagCv; 
  Boolean            connectedFlagCv;
  char               ipAddressCv[20];

public:
  SOCK_Socket (Boolean serverFlag = FALSE);

  SOCK_Socket(int clientFd, struct sockaddr_in *clientSinPtr);

  virtual
	~SOCK_Socket();

  virtual Status
  BindAndListen(Word port, Word number = 5);

  virtual SOCK_Socket *
  Accept(void);

  virtual Status
  Connect(char *ipAddress, Word port);

  virtual Status
  Disconnect();

  virtual Status
  GetChar(char &ch /* out: */);

  virtual int
  GetChar(void);

  virtual Status
  PutChar(char ch /* in : */);

  virtual Status
  PutString (char *str /* in: */);

  virtual Status
  GetString (char *str);

  virtual Status
  PutStrings (char * str, int len);
};

#endif
